<?php
/*
 * ARI Quiz Activity for JomSocial Joomla! system plugin
 *
 * @package		ARI Quiz Activity for JomSocial
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemAriquizjsactivity extends JPlugin
{
	function plgSystemAriquizjsactivity(&$subject, $params)
	{
		parent::__construct($subject, $params);		
	}
	
	/*
	 * This method calls when user finishes quiz
	 * 
	 * @param    array  $params    Hash with the following keys
	 * 
	 * StatisticsInfoId
	 * UserName - user name
	 * QuizName - quiz name
	 * PassedScore - passed score
	 * MaxScore - max score
	 * UserScore - user score
	 * PercentScore - percent score
	 * _Passed - passed or not (1 or 0)
	 * StartDate - start date
	 * EndDate - end date
	 * SpentTime - spent time
	 * QuizId - quiz id
	 * 
	 * @access   public
	 */
	function onEndQuiz($quizParams)
	{
		$user =& JFactory::getUser();
		if (empty($user->id))
			return ;
		
		$kernelPath = JPATH_ROOT . '/administrator/components/com_ariquiz/kernel/class.AriKernel.php';
		require_once $kernelPath;
		
		AriKernel::import('Utils.Utils');
		AriKernel::import('SimpleTemplate.SimpleTemplate');
			
		$params = $this->params;
		$isPassed = $quizParams['_Passed'];
		$addForPassed = AriUtils::parseValueBySample($params->get('addpassedquiz', false), false);
		$addForFailed = AriUtils::parseValueBySample($params->get('addfailedquiz', false), false);
		
		if (($isPassed && !$addForPassed) || (!$isPassed && !$addForFailed))
			return ;
			
		$message = $this->params->get($isPassed ? 'quizpassedmessage' : 'quizfailedmessage');
		if (empty($message))
			return ;
			
		require_once JPATH_ROOT . '/components/com_community/libraries/core.php';
		require_once JPATH_ROOT . '/components/com_content/helpers/route.php';

		CFactory::load('libraries', 'activities');

		$act = new stdClass();
		$my	=& CFactory::getUser($user->id);

		$quizParams['QuizLink'] = JRoute::_('index.php?option=com_ariquiz&view=quiz&quizId=' . $quizParams['QuizId']);
		$message = AriSimpleTemplate::parse($message, $quizParams);

		$act->cmd = $isPassed ? 'ariquiz.passed' : 'ariquiz.failed';
		$act->actor	= $my->id;
		$act->target = 0;
		$act->title	= JText::_($message);
		//$act->content	= JText::_($message);
		$act->app = 'com_ariquiz.quizresults';
		$act->access  = 0;
		$act->cid = 0;//$my->id;
		CActivityStream::add($act);

		return true;
	}
}