<?php
/*
 * ARI Quiz Results for JomSocial
 *
 * @package		ARI Quiz Results for JomSocial
 * @version		1.0.0
 * @author		ARI Soft
 * @copyright	Copyright (c) 2010 www.ari-soft.com. All rights reserved
 * @license		GNU/GPL (http://www.gnu.org/copyleft/gpl.html)
 * 
 */

defined('_JEXEC') or die('Restricted access');

require_once JPATH_BASE . '/components/com_community/libraries/core.php';

class plgCommunityAriquizresults extends CApplications
{
	var $name = 'ARI Quiz Results';
	var $_name = 'ariquizresults'; 
	var $_user;

	function plgCommunityAriquizresults(&$subject, $config)
    {
    	$this->_user = CFactory::getActiveProfile();
		$this->_my = CFactory::getUser();
		
		parent::__construct($subject, $config);
    }
    
    function onProfileDisplay()
	{
		if (!$this->loadFramework())
		{
			return '<b style="color: red;">Quizzes results can\'t be shown. Check, please, that ARI Quiz component is correctly installed and you have version 2.7.1+.</b>';			
		}
		
		$lang = JFactory::getLanguage();
		$lang->load('com_ariquiz');
		
		$user = $this->_my;
		$params = $this->params;
		$sortField = $params->get('sort', 'EndDate2');
		$sortOrder = $params->get('sortOrder', 'DESC');

		//$dsUrl = JURI::root(true) . '/index.php?option=community&task=azrul_ajax&func=plugins,ariquizresults,ajaxGetResults&sortField=' . $sortField . '&sortOrder=' . $sortOrder;
		$dsUrl = JURI::root(true) . '/index.php?option=com_ariquiz&view=quizresults&task=ajaxGetResultList';
		$columns = array(
			new AriDataTableControlColumn(array('key' => '', 'label' => JText::_('COM_ARIQUIZ_LABEL_NUMPOS'), 'formatter' => 'YAHOO.ARISoft.widgets.DataTable.formatters.formatPosition', 'className' => 'dtCenter dtColMin')),
			new AriDataTableControlColumn(array('key' => 'QuizName', 'label' => JText::_('COM_ARIQUIZ_LABEL_QUIZ'), 'sortable' => true)),
			new AriDataTableControlColumn(array('key' => 'StartDate2', 'label' => JText::_('COM_ARIQUIZ_LABEL_STARTDATE'), 'sortable' => true)),
			new AriDataTableControlColumn(array('key' => 'EndDate2', 'label' => JText::_('COM_ARIQUIZ_LABEL_ENDDATE'), 'sortable' => true)),
			new AriDataTableControlColumn(array('key' => 'UserScore', 'label' => '', 'hidden' => true)),
			new AriDataTableControlColumn(array('key' => 'MaxScore', 'label' => '', 'hidden' => true)),
			new AriDataTableControlColumn(array('key' => 'PercentScore', 'label' => JText::_('COM_ARIQUIZ_LABEL_SCORE'), 'sortable' => true, 'formatter' => 'YAHOO.ARISoft.Quiz.formatters.formatResultScore', 'className' => 'dtNoWrap')),
			new AriDataTableControlColumn(array('key' => 'Passed', 'label' => JText::_('COM_ARIQUIZ_LABEL_STATUS'), 'sortable' => true, 'formatter' => 'YAHOO.ARISoft.Quiz.formatters.formatPassed'))
		);
		
		if ($user->id == $this->_user->id)
			$columns[] = new AriDataTableControlColumn(array('key' => 'ResultsLink', 'label' => JText::_('COM_ARIQUIZ_LABEL_DETAILS'), 'formatter' => 'YAHOO.ARISoft.Quiz.formatters.formatUserResultDetails'));

		$dataTable = new AriMultiPageDataTableControl(
			'dtAriQuizResults',
			$columns,
			array('dataUrl' => $dsUrl),
			array(
				'firstPageLinkLabel' => null,
				'lastPageLinkLabel' => null,
				'nextPageLinkLabel' => null,
				'previousPageLinkLabel' => null,
				'pageReportTemplate' => null,
				'template' => '<div style="text-align: center;">Display#: {RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink} {CurrentPageReport}</div>'
			),
			null,
			true,
			true);
		
		@ob_start();
		$dataTable->render();
		$dtDefinition = ob_get_contents();
		@ob_clean();
		@ob_end_flush();

	    $beforeText = $params->get('beforeText', '');
		$afterText = $params->get('afterText', '');
		
		$liveSite = JURI::base(true);
		$jsAdminPath = $liveSite . '/components/com_ariquiz/assets/js/';
		$cssPath = $liveSite . '/components/com_ariquiz/assets/css/';

		$content = sprintf(
			'<link rel="stylesheet" type="text/css" href="%1$syui.combo.css" />
			<link rel="stylesheet" type="text/css" href="%1$sstyles.css" />
			<script type="text/javascript" src="%2$syui.combo.js"></script>
			<script charset="utf-8" src="%2$sari.all.js?v=%3$s" type="text/javascript"></script>
			<script charset="utf-8" src="%2$sari.quiz.js?v=%3$s" type="text/javascript"></script>
			<script charset="utf-8" src="%2$sari.pageController.js?v=%3$s" type="text/javascript"></script>
			<script charset="utf-8" src="%7$s/index.php?option=com_ariquiz&view=jsmessages&task=getMessages" type="text/javascript"></script> 
			<script type="text/javascript">
				YAHOO.ARISoft.page.baseUrl = "%7$s/";
				YAHOO.ARISoft.page.adminBaseUrl = "%7$s/administrator/";
				YAHOO.ARISoft.page.option = "com_ariquiz";
			</script>
			%5$s
			<div class="yui-skin-sam">%4$s</div>
			%6$s',
			$cssPath,
			$jsAdminPath,
			time(),
			$dtDefinition,
			$beforeText,
			$afterText,
			$liveSite
		);

		return $content;
	}
	
	function ajaxGetResults(&$response)
	{
		if (!$this->loadFramework())
			return $response;
		
		$userId = $this->_user->id;
		$sortField = JRequest::getString('sortField');
		$sortDirection = JRequest::getString('sortOrder');
		
				$filter = new AriDataFilter(
			array(
				'startOffset' => 0, 
				'limit' => 10, 
				'sortField' => $sortField, 
				'dir' => $sortDirection,
				'filter' => array(
					'UserId' => $userId
				)
			), 
			true, 
			null
		);

		$resultsModel =& JModel::getInstance('Quizresults', 'AriQuizModel');
		$totalCnt = $resultsModel->getResultCount($filter);
		$filter->fixFilter($totalCnt);

		$results = $this->_extendStats(
			$resultsModel->getResultList($filter)
		);		
		$data = AriMultiPageDataTableControl::createDataInfo($results, $filter, $totalCnt); 

		while (@ob_end_clean());
		
		header('Content-type: text/html; charset=utf-8');
		
		echo json_encode($data);
		exit();
	}
	
	function _extendStats($results)
	{
		if (empty($results)) return $results;

		global $Itemid;
		
		for ($i = 0; $i < count($results); $i++)
		{
			$result =& $results[$i];
			$result->DetailsLink = AriJoomlaBridge::getLink(
				'index.php?option=com_ariquiz&task=quiz_finished&ticketId=' . $result->TicketId . '&Itemid=' . $Itemid, false, false, false);
		}
		
		return $results;
	}
	
	function loadFramework()
	{
		static $loaded;

		if (!is_null($loaded)) return $loaded;
		
		$kernelPath = JPATH_ROOT . '/administrator/components/com_ariquiz/kernel/class.AriKernel.php';
		if (!@file_exists($kernelPath))
		{
			$loaded = false;
			return $loaded;
		}
		
		require_once $kernelPath;
		
		AriKernel::import('SimpleTemplate.SimpleTemplate');
		AriKernel::import('Web.Controls.Data.MultiPageDataTable');
		AriKernel::import('Web.JSON.JSON');
		AriKernel::import('Data.DataFilter');
		
		require_once JPATH_ADMINISTRATOR . '/components/com_ariquiz/models/quizresults.php';
		require_once JPATH_ADMINISTRATOR . '/components/com_ariquiz/tables/quiz.php';
		require_once JPATH_ADMINISTRATOR . '/components/com_ariquiz/tables/userquiz.php';
				
		$loaded = true;
		
		return $loaded;
	}
}